/*
 * menushki: -- converts the menus between different Desktop Environments
 * Copyright (C) 2001 Alex "Loki" Agibalov <loki_bg@yahoo.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __GLOB_H__
#define __GLOB_H__

// number should be increased, when items added to mainmenu
#define MENUITEMS 7
#define FIRSTITEMS 3

// program version
char m_version[]="v0.7";

// Available window managers (items)
char *mainmenu[MENUITEMS]= 
    {"WindowMaker", 
    "KDE",
    "IceWM", 
    "GNOME", 
    "BlackBox", 
    "Enlightenment",
    "Exit"};
    
// initial menu
char *firstmenu[FIRSTITEMS]=
    {"Go converting",
    "Menu editor",
    "Exit"};
    
// Structure to store info about the menu item
struct mItem {
    char *name;
    char *fname;
    char *exec;
    char *icon;
    char *comment;
    char *terminal;
    char *type;
    struct mItem *nextItem;
};

typedef struct mItem M_ITEM;
typedef M_ITEM *M_ITEMptr;

// menu buffer
M_ITEMptr mBuf=NULL;

// Tmp file
FILE *fTmp;

// Buffer
char retBuf[256];

// for debugging
char st[256];

// temp storage
char s00[256];

// current directory
char currdir[256];

#endif /* __GLOB_H__ */



